package queuetest;

public class QueueDL {

    private NodeDL dummyHead;
    private NodeDL dummyTail;
    private int size;
//--------------------------------------------------------------

    public QueueDL() // constructor
    {
        dummyHead = new NodeDL(null,null,null);
        dummyTail = new NodeDL(dummyHead,null,null);
        dummyHead.next=dummyTail;
        size = 0;
    }
//--------------------------------------------------------------

    public void enqueue(Object j) // put item on head of queue
    {
        //add to linked list
        size++;
        NodeDL nN=new NodeDL(dummyHead,j,dummyHead.next);
        dummyHead.next.prev=nN;
        dummyHead.next=nN;
        
    }
//--------------------------------------------------------------

    public Object dequeue() // take item from end of queue
    {
        //remove from linked list
        NodeDL temp=dummyTail.prev;
        if (size != 0) {
            size--;
            dummyTail.prev.prev.next=dummyTail;
            dummyTail.prev=dummyTail.prev.prev;
        }
        temp.prev=null;
        temp.next=null;
        return temp.data;
    }
//--------------------------------------------------------------

    public Object peek() // peek at end of queue
    {
        return dummyTail.prev.data;
    }
//--------------------------------------------------------------

    public boolean isEmpty() // true if queue is empty
    {
        return (size == 0);
    }
///--------------------------------------------------------------

    public int size() // true if queue is empty
    {
        return size;
    }

    public void display() // display queue content
    {
        NodeDL temp = dummyHead.next;
        int i=1;
        while (temp != dummyTail) {
            System.out.println(i+":"+ temp.data);
            temp = temp.next;
            i++;
        }
    }

}
